// BakalarskaPrace_Benchmark_D2D_GDI.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "BakalarskaPrace_Benchmark_D2D_GDI.h"

#define MAX_LOADSTRING 100

// povoleni common controls 6 tj. lepsi vizualni styly prvku
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")


// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
HWND m_hwnd = NULL;								// globalni handle k hlavnimu oknu
ID2D1Factory *m_pD2DFactory = NULL;				// globalni D2D tovarna
GdiplusStartupInput gdiplusStartupInput;		// globalni GDI+ inicializace
ULONG_PTR           gdiplusToken;


HWND hStext, hBstart;		// staticky text - informacni okno, tlacitko na startovani testu
HWND hList;					// vyber narocnosti testu
HANDLE hEvent;				// event pro komunikaci mezi threadem, ktery spousti test
HANDLE hThread;				// handle na druhe vlakno
int zobrazVysledek{ 0 };	// promenna, ktera umozni zobrazeni vysledku ve WM_PAINT

//ovladani testu nasobeni poctu vykresleni testu celkove pro vsechny daneho typu GDI, GDI+ a D2D
int gdiPocet{ 100 }, gdiplusPocet{ 100 }, d2dPocet{ 100 };

// konecne vysledky - prumery rychlosti a promerne pocty cyklu CPU, variacni koeficient
// GDI - g, GDI+ - gp, D2D - d
int gTest1{ 0 }, gpTest1{ 0 }, dTest1{ 0 };
ULONG64 cgTest1{ 0 }, cgpTest1{ 0 }, cdTest1{ 0 };
double vgTest1{ 0 }, vgpTest1{ 0 }, vdTest1{ 0 };
int gTest2{ 0 }, gpTest2{ 0 }, dTest2{ 0 };
ULONG64 cgTest2{ 0 }, cgpTest2{ 0 }, cdTest2{ 0 };
double vgTest2{ 0 }, vgpTest2{ 0 }, vdTest2{ 0 };
int swdTest3{ 0 }, swadTest3{ 0 }, hwadTest3{ 0 };
ULONG64 cswdTest3{ 0 }, cswadTest3{ 0 }, chwadTest3{ 0 };
double vswdTest3{ 0 }, vswadTest3{ 0 }, vhwadTest3{ 0 };
int gTest4{ 0 }, gpTest4{ 0 }, dTest4{ 0 };
ULONG64 cgTest4{ 0 }, cgpTest4{ 0 }, cdTest4{ 0 };
double vgTest4{ 0 }, vgpTest4{ 0 }, vdTest4{ 0 };
int gTest5{ 0 }, gpTest5{ 0 }, dTest5{ 0 };
ULONG64 cgTest5{ 0 }, cgpTest5{ 0 }, cdTest5{ 0 };
double vgTest5{ 0 }, vgpTest5{ 0 }, vdTest5{ 0 };
int dcdTest6{ 0 }, dTest6{ 0 };
ULONG64 cdcdTest6{ 0 }, cdTest6{ 0 };
double vdcdTest6{ 0 }, vdTest6{ 0 };
int gdidTest7{ 0 }, gTest7{ 0 };
ULONG64 cgdidTest7{ 0 }, cgTest7{ 0 };
double vgdidTest7{ 0 }, vgTest7{ 0 };
int gTest8{ 0 }, gpTest8{ 0 }, dTest8{ 0 };
ULONG64 cgTest8{ 0 }, cgpTest8{ 0 }, cdTest8{ 0 };
double vgTest8{ 0 }, vgpTest8{ 0 }, vdTest8{ 0 };
int swdTest9{ 0 }, swadTest9{ 0 }, hwadTest9{ 0 };
ULONG64 cswdTest9{ 0 }, cswadTest9{ 0 }, chwadTest9{ 0 };
double vswdTest9{ 0 }, vswadTest9{ 0 }, vhwadTest9{ 0 };


// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	HRESULT hr;
	hr = CreateDeviceIndependentResources(); // vytvoreni tovarny D2D
	
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL); // inicializace GDI+

	if (hr) // pokud se tovarna nepovedla vytvorit, ukoncime aplikaci
	{
		return FALSE;
	}

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_BAKALARSKAPRACE_BENCHMARK_D2D_GDI, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_BAKALARSKAPRACE_BENCHMARK_D2D_GDI));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= NULL;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_BAKALARSKAPRACE_BENCHMARK_D2D_GDI));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_BAKALARSKAPRACE_BENCHMARK_D2D_GDI);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   // Because the CreateWindow function takes its size in pixels, we
   // obtain the system DPI and use it to scale the window size.
   FLOAT dpiX, dpiY;
   m_pD2DFactory->GetDesktopDpi(&dpiX, &dpiY);

   // | WS_CLIPCHILDREN umozni neblikajici textove pole napriklad pokud ma hlavni okno jako parenta (tlacitko ma definovane HWND)
   // aby D2D a jine API neprekreslovala ovladaci prvky (tlacitka atd.), pouzijeme WS_CLIPCHILDREN
   // WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION
   hWnd = CreateWindow(szWindowClass, szTitle, WS_SYSMENU | WS_CAPTION | WS_CLIPCHILDREN,
	   0, 0, 1024, 600, // zvoleno rozliseni napevno podobne jako minimalni pozadavky VISTA/7 1024x600
	   NULL, NULL, hInstance, NULL);

   m_hwnd = hWnd; // naplnime globalni handle

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{

	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
			case IDB_START:
			{
				int count = SendMessageA(hList, LB_GETCOUNT, 0, 0);
				int iSelected = -1;

				// hledm prvn vybranou poloku
				for (int i = 0; i < count; i++)
				{
					// kontrola kad poloky, jestli je vybran i ne
					if (SendMessageA(hList, LB_GETSEL, i, 0) > 0)
					{
						// jeliko chci jen prvn vybranou (vbr vce nen nastaven v Listboxu) poloku, po nalezen konim
						iSelected = i;
						break;
					}
				}

				// kdy vm index vybran poloky, zjistim na zklad toho text a jestli odpovd monostem
				if (iSelected != -1)
				{
					char kolikrat[30];
					int ok = 0;
					SendMessageA(hList, LB_GETTEXT, (WPARAM)iSelected, (LPARAM)kolikrat);

					if (strcmp(kolikrat, "100x") == 0)
					{
						gdiPocet = 100, gdiplusPocet = 100, d2dPocet = 100;
						ok = 1;
					}
					else if (strcmp(kolikrat, "1x") == 0)
					{
						gdiPocet = 1, gdiplusPocet = 1, d2dPocet = 1;
						ok = 1;
					}
					else if (strcmp(kolikrat, "1000x") == 0)
					{
						gdiPocet = 1000, gdiplusPocet = 1000, d2dPocet = 1000;
						ok = 1;
					}
						
					if (ok == 1)
					{
						ShowWindow(hList, SW_HIDE);
						ShowWindow(hBstart, SW_HIDE);
						SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
						hEvent = CreateEvent(NULL, FALSE, FALSE, L"Testovani");
						DWORD threadID;
						// vytvoreni druheho vlakna, ktere nezavisle na prvnim testuje
						hThread = CreateThread(NULL, 0, testovani, NULL, 0, &threadID);
					}
				}
				else
				{
					MessageBoxA(hWnd, "Nebyla vybrna nronost testu.", "Nelze testovat!", MB_OK);
				}
			}
				break;

			case IDM_ABOUT:
				DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
				break;
			case IDM_EXIT:
				DestroyWindow(hWnd);
				break;
			default:
				return DefWindowProc(hWnd, message, wParam, lParam);
		}
			break;
	
	// kvuli posouvani okna - GDI+ nevykresluje nic, pokud je okno mimo obrazovku
	case WM_MOVING:
	{
		GetWindowRect(hWnd, (RECT*)lParam);
	}
		break;

	case WM_CTLCOLORBTN:
	{
		// zniceni sedeho ramecku (pozadi) u tlacitek
		HDC hdc = (HDC)wParam;
		SetBkMode(hdc, TRANSPARENT);
	}
		break;

	case WM_CTLCOLORSTATIC:
	{
		if (hStext == (HWND)lParam)
		{
			// nastaveni pruhlednosti a barvy textu
			HDC hdcStatic = (HDC)wParam;
			SetTextColor(hdcStatic, RGB(255, 0, 0));
			SetBkMode(hdcStatic, TRANSPARENT);
		}
		else
		{
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
	}
		break;

	case WM_CREATE:
	{
		hStext = CreateWindowEx(0, L"Static", L"Tlatkem START se spust test.", WS_CHILD | WS_VISIBLE | SS_CENTER, 252, 0, 504, 18, hWnd, NULL, NULL, NULL);
		hBstart = CreateWindowEx(0, L"BUTTON", L"START", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 429, 25, 150, 50, hWnd, (HMENU)IDB_START, NULL, NULL);
		hList = CreateWindowExA(WS_EX_CLIENTEDGE, "Listbox", "", WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_AUTOVSCROLL, 429, 85, 150, 60, hWnd, (HMENU)IDL_VYBER, NULL, NULL);
		SendMessageA(hList, LB_ADDSTRING, 0, (LPARAM)"1x");
		SendMessageA(hList, LB_ADDSTRING, 0, (LPARAM)"100x");
		SendMessageA(hList, LB_ADDSTRING, 0, (LPARAM)"1000x");
	}
		break;


	case testuj:
	{
		switch (wParam)
		{
			case 666:
			{
				RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);
				SetEvent(hEvent);
			}
				break;

		}	// default neni potreba, pokud hodnota neodpovida case tak se proste preskoci cely switch coz je ok
	}		
		break;	
		
	case WM_PAINT:
	{
		hdc = BeginPaint(hWnd, &ps);
		OnRender(hdc);
		EndPaint(hWnd, &ps);
	}
		break;

	case WM_DESTROY:
	{    
		// tyto neni treba ukoncovat - OS sam vycisti pamet po vypnuti, pracujeme s nima prakticky do konce aplikace 
		// jinak by to hazelo vyjimky ze druhy thread s nima jeste pracuje a nez se ukonci prvni tak druhy pracuje s prazdnymi daty
		//SafeRelease(&m_pD2DFactory);
		//GdiplusShutdown(gdiplusToken);
		PostQuitMessage(0); 
	}
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}


// ******************************************************************** //
// Create resources which are not bound to any device. 
// Their lifetime effectively extends for the duration of the app. 

HRESULT CreateDeviceIndependentResources()
{
	// tvorba D2D tovarny
	return D2D1CreateFactory(D2D1_FACTORY_TYPE_SINGLE_THREADED, &m_pD2DFactory);
}

 

void OnRender(HDC hdc)
{
	// ZDE SE VYKRESLI VYSLEDKY ZE VSECH PROMENNYCH DO KTERYCH SE UKLADALY TESTY
	// format vystupu: 9273 us [3200 fps]  V=10%  83764873 cykl CPU
	
	if (zobrazVysledek == 1)
	{		
		if (gTest1 != 0 && gpTest1 != 0 && dTest1 != 0 &&
			gTest2 != 0 && gpTest2 != 0 && dTest2 != 0 &&
			swdTest3 != 0 && swadTest3 != 0 && hwadTest3 != 0 &&
			gTest4 != 0 && gpTest4 != 0 && dTest4 != 0 &&
			gTest5 != 0 && gpTest5 != 0 && dTest5 != 0)
		{
			TextOutA(hdc, 140, 20, "s - mikrosekunda (1s = 1000ms = 1000000s), fps - snmky za sekundu, V - varian koeficient", strlen("s - mikrosekunda (1s = 1000ms = 1000000s), fps - snmky za sekundu, V - varian koeficient"));

			TextOutA(hdc, 20, 40, "1. test - seky", strlen("1. test - seky"));
			TextOutA(hdc, 50, 60, "GDI >>", strlen("GDI >>"));
			TextOutA(hdc, 50, 80, "GDI+ >>", strlen("GDI+ >>"));
			TextOutA(hdc, 50, 100, "Direct2D >>", strlen("Direct2D >>"));

			string gprvni;
			gprvni = to_string(gTest1) + " s [" + to_string((1000000 / gTest1)) + " fps]  V=" + to_string((int) round(vgTest1)) + "%  ";
			gprvni += to_string(cgTest1) + " cykl CPU";
			TextOutA(hdc, 140, 60, gprvni.c_str(), strlen(gprvni.c_str()));

			string gpprvni;
			gpprvni = to_string(gpTest1) + " s [" + to_string((1000000 / gpTest1)) + " fps]  V=" + to_string((int) round(vgpTest1)) + "%  ";
			gpprvni += to_string(cgpTest1) + " cykl CPU";
			TextOutA(hdc, 140, 80, gpprvni.c_str(), strlen(gpprvni.c_str()));

			string dprvni;
			dprvni = to_string(dTest1) + " s [" + to_string((1000000 / dTest1)) + " fps]  V=" + to_string((int) round(vdTest1)) + "%  ";
			dprvni += to_string(cdTest1) + " cykl CPU";
			TextOutA(hdc, 140, 100, dprvni.c_str(), strlen(dprvni.c_str()));


			TextOutA(hdc, 20, 140, "2. test - krunice", strlen("2. test - krunice"));
			TextOutA(hdc, 50, 160, "GDI >>", strlen("GDI >>"));
			TextOutA(hdc, 50, 180, "GDI+ >>", strlen("GDI+ >>"));
			TextOutA(hdc, 50, 200, "Direct2D >>", strlen("Direct2D >>"));

			string gdruhy;
			gdruhy = to_string(gTest2) + " s [" + to_string((1000000 / gTest2)) + " fps]  V=" + to_string((int) round(vgTest2)) + "%  ";
			gdruhy += to_string(cgTest2) + " cykl CPU";
			TextOutA(hdc, 140, 160, gdruhy.c_str(), strlen(gdruhy.c_str()));

			string gpdruhy;
			gpdruhy = to_string(gpTest2) + " s [" + to_string((1000000 / gpTest2)) + " fps]  V=" + to_string((int) round(vgpTest2)) + "%  ";
			gpdruhy += to_string(cgpTest2) + " cykl CPU";
			TextOutA(hdc, 140, 180, gpdruhy.c_str(), strlen(gpdruhy.c_str()));

			string ddruhy;
			ddruhy = to_string(dTest2) + " s [" + to_string((1000000 / dTest2)) + " fps]  V=" + to_string((int) round(vdTest2)) + "%  ";
			ddruhy += to_string(cdTest2) + " cykl CPU";
			TextOutA(hdc, 140, 200, ddruhy.c_str(), strlen(ddruhy.c_str()));
			
			
			TextOutA(hdc, 20, 240, "3. test - krunice, pouze Direct2D - SW/HW renderovn a antialiasing (AA)", strlen("3. test - krunice, pouze Direct2D - SW/HW renderovn a antialiasing (AA)"));
			TextOutA(hdc, 50, 260, "SW >>", strlen("SW >>"));
			TextOutA(hdc, 50, 280, "SW + AA >>", strlen("SW + AA >>"));
			TextOutA(hdc, 50, 300, "HW + AA >>", strlen("HW + AA >>"));

			string swdtreti;
			swdtreti = to_string(swdTest3) + " s [" + to_string((1000000 / swdTest3)) + " fps]  V=" + to_string((int)round(vswdTest3)) + "%  ";
			swdtreti += to_string(cswdTest3) + " cykl CPU";
			TextOutA(hdc, 140, 260, swdtreti.c_str(), strlen(swdtreti.c_str()));

			string swadtreti;
			swadtreti = to_string(swadTest3) + " s [" + to_string((1000000 / swadTest3)) + " fps]  V=" + to_string((int)round(vswadTest3)) + "%  ";
			swadtreti += to_string(cswadTest3) + " cykl CPU";
			TextOutA(hdc, 140, 280, swadtreti.c_str(), strlen(swadtreti.c_str()));

			string hwadtreti;
			hwadtreti = to_string(hwadTest3) + " s [" + to_string((1000000 / hwadTest3)) + " fps]  V=" + to_string((int)round(vhwadTest3)) + "%  ";
			hwadtreti += to_string(chwadTest3) + " cykl CPU";
			TextOutA(hdc, 140, 300, hwadtreti.c_str(), strlen(hwadtreti.c_str()));


			TextOutA(hdc, 20, 340, "4. test - krunice (renderovn do pamti)", strlen("4. test - krunice (renderovn do pamti)"));
			TextOutA(hdc, 50, 360, "GDI >>", strlen("GDI >>"));
			TextOutA(hdc, 50, 380, "GDI+ >>", strlen("GDI+ >>"));
			TextOutA(hdc, 50, 400, "Direct2D >>", strlen("Direct2D >>"));

			string gctvrty;
			gctvrty = to_string(gTest4) + " s [" + to_string((1000000 / gTest4)) + " fps]  V=" + to_string((int)round(vgTest4)) + "%  ";
			gctvrty += to_string(cgTest4) + " cykl CPU";
			TextOutA(hdc, 140, 360, gctvrty.c_str(), strlen(gctvrty.c_str()));

			string gpctvrty;
			gpctvrty = to_string(gpTest4) + " s [" + to_string((1000000 / gpTest4)) + " fps]  V=" + to_string((int)round(vgpTest4)) + "%  ";
			gpctvrty += to_string(cgpTest4) + " cykl CPU";
			TextOutA(hdc, 140, 380, gpctvrty.c_str(), strlen(gpctvrty.c_str()));

			string dctvrty;
			dctvrty = to_string(dTest4) + " s [" + to_string((1000000 / dTest4)) + " fps]  V=" + to_string((int)round(vdTest4)) + "%  ";
			dctvrty += to_string(cdTest4) + " cykl CPU";
			TextOutA(hdc, 140, 400, dctvrty.c_str(), strlen(dctvrty.c_str()));


			TextOutA(hdc, 20, 440, "5. test - renderovn bitmapy ze souboru", strlen("5. test - renderovn bitmapy ze souboru"));
			TextOutA(hdc, 50, 460, "GDI >>", strlen("GDI >>"));
			TextOutA(hdc, 50, 480, "GDI+ >>", strlen("GDI+ >>"));
			TextOutA(hdc, 50, 500, "Direct2D >>", strlen("Direct2D >>"));

			string gpaty;
			gpaty = to_string(gTest5) + " s [" + to_string((1000000 / gTest5)) + " fps]  V=" + to_string((int)round(vgTest5)) + "%  ";
			gpaty += to_string(cgTest5) + " cykl CPU";
			TextOutA(hdc, 140, 460, gpaty.c_str(), strlen(gpaty.c_str()));

			string gppaty;
			gppaty = to_string(gpTest5) + " s [" + to_string((1000000 / gpTest5)) + " fps]  V=" + to_string((int)round(vgpTest5)) + "%  ";
			gppaty += to_string(cgpTest5) + " cykl CPU";
			TextOutA(hdc, 140, 480, gppaty.c_str(), strlen(gppaty.c_str()));

			string dpaty;
			dpaty = to_string(dTest5) + " s [" + to_string((1000000 / dTest5)) + " fps]  V=" + to_string((int)round(vdTest5)) + "%  ";
			dpaty += to_string(cdTest5) + " cykl CPU";
			TextOutA(hdc, 140, 500, dpaty.c_str(), strlen(dpaty.c_str()));


			TextOutA(hdc, 520, 140, "6. test - kreslen tverc Direct2D a z Direct2D do DC GDI", strlen("6. test - kreslen tverc Direct2D a z Direct2D do DC GDI"));
			TextOutA(hdc, 550, 160, "D2D-HWND >>", strlen("D2D-HWND >>"));
			TextOutA(hdc, 550, 180, "D2D-DC >>", strlen("D2D-DC >>"));

			string dsesty;
			dsesty = to_string(dTest6) + " s [" + to_string((1000000 / dTest6)) + " fps]  V=" + to_string((int)round(vdTest6)) + "%  ";
			dsesty += to_string(cdTest6) + " cykl CPU";
			TextOutA(hdc, 660, 160, dsesty.c_str(), strlen(dsesty.c_str()));

			string dcdsesty;
			dcdsesty = to_string(dcdTest6) + " s [" + to_string((1000000 / dcdTest6)) + " fps]  V=" + to_string((int)round(vdcdTest6)) + "%  ";
			dcdsesty += to_string(cdcdTest6) + " cykl CPU";
			TextOutA(hdc, 660, 180, dcdsesty.c_str(), strlen(dcdsesty.c_str()));


			TextOutA(hdc, 520, 240, "7. test - kreslen tverc GDI a z GDI do Direct2D", strlen("7. test - kreslen tverc GDI a z GDI do Direct2D"));
			TextOutA(hdc, 550, 260, "GDI >>", strlen("GDI >>"));
			TextOutA(hdc, 550, 280, "GDI-D2D >>", strlen("GDI-D2D >>"));

			string gsedmy;
			gsedmy = to_string(gTest7) + " s [" + to_string((1000000 / gTest7)) + " fps]  V=" + to_string((int)round(vgTest7)) + "%  ";
			gsedmy += to_string(cgTest7) + " cykl CPU";
			TextOutA(hdc, 660, 260, gsedmy.c_str(), strlen(gsedmy.c_str()));

			string gdidsedmy;
			gdidsedmy = to_string(gdidTest7) + " s [" + to_string((1000000 / gdidTest7)) + " fps]  V=" + to_string((int)round(vgdidTest7)) + "%  ";
			gdidsedmy += to_string(cgdidTest7) + " cykl CPU";
			TextOutA(hdc, 660, 280, gdidsedmy.c_str(), strlen(gdidsedmy.c_str()));


			TextOutA(hdc, 520, 340, "8. test - renderovn textu", strlen("8. test - renderovn textu"));
			TextOutA(hdc, 550, 360, "GDI >>", strlen("GDI >>"));
			TextOutA(hdc, 550, 380, "GDI+ >>", strlen("GDI+ >>"));
			TextOutA(hdc, 550, 400, "Direct2D >>", strlen("Direct2D >>"));

			string gosmy;
			gosmy = to_string(gTest8) + " s [" + to_string((1000000 / gTest8)) + " fps]  V=" + to_string((int)round(vgTest8)) + "%  ";
			gosmy += to_string(cgTest8) + " cykl CPU";
			TextOutA(hdc, 660, 360, gosmy.c_str(), strlen(gosmy.c_str()));

			string gposmy;
			gposmy = to_string(gpTest8) + " s [" + to_string((1000000 / gpTest8)) + " fps]  V=" + to_string((int)round(vgpTest8)) + "%  ";
			gposmy += to_string(cgpTest8) + " cykl CPU";
			TextOutA(hdc, 660, 380, gposmy.c_str(), strlen(gposmy.c_str()));

			string dosmy;
			dosmy = to_string(dTest8) + " s [" + to_string((1000000 / dTest8)) + " fps]  V=" + to_string((int)round(vdTest8)) + "%  ";
			dosmy += to_string(cdTest8) + " cykl CPU";
			TextOutA(hdc, 660, 400, dosmy.c_str(), strlen(dosmy.c_str()));


			TextOutA(hdc, 520, 440, "9. test - renderovn textu, pouze Direct2D - SW/HW a antialiasing (AA)", strlen("9. test - renderovn textu, pouze Direct2D - SW/HW a antialiasing (AA)"));
			TextOutA(hdc, 550, 460, "SW >>", strlen("SW >>"));
			TextOutA(hdc, 550, 480, "SW + AA >>", strlen("SW + AA >>"));
			TextOutA(hdc, 550, 500, "HW + AA >>", strlen("HW + AA >>"));

			string swddevaty;
			swddevaty = to_string(swdTest9) + " s [" + to_string((1000000 / swdTest9)) + " fps]  V=" + to_string((int)round(vswdTest9)) + "%  ";
			swddevaty += to_string(cswdTest9) + " cykl CPU";
			TextOutA(hdc, 660, 460, swddevaty.c_str(), strlen(swddevaty.c_str()));

			string swaddevaty;
			swaddevaty = to_string(swadTest9) + " s [" + to_string((1000000 / swadTest9)) + " fps]  V=" + to_string((int)round(vswadTest9)) + "%  ";
			swaddevaty += to_string(cswadTest9) + " cykl CPU";
			TextOutA(hdc, 660, 480, swaddevaty.c_str(), strlen(swaddevaty.c_str()));

			string hwaddevaty;
			hwaddevaty = to_string(hwadTest9) + " s [" + to_string((1000000 / hwadTest9)) + " fps]  V=" + to_string((int)round(vhwadTest9)) + "%  ";
			hwaddevaty += to_string(chwadTest9) + " cykl CPU";
			TextOutA(hdc, 660, 500, hwaddevaty.c_str(), strlen(hwaddevaty.c_str()));
			
		}
		else
		{
			TextOutA(hdc, 140, 60, "ERROR - DLEN NULOU", strlen("ERROR - DLEN NULOU"));
		}

	}

}



DWORD WINAPI testovani(LPVOID iValue)
{
	SetWindowTextA(hStext, "ZAN PRVN TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "PRVN TEST > seky");
	test1();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW); // vycisteni plochy

	SetWindowTextA(hStext, "ZAN DRUH TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "DRUH TEST > krunice");
	test2();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "ZAN TET TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "TET TEST > krunice, D2D pouze (SW/HW renderovn + antialiasing)");
	test3();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "ZAN TVRT TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "TVRT TEST > krunice (renderovn do pamti)");
	test4();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "ZAN PT TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "PT TEST > renderovn bitmapy ze souboru");
	test5();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "ZAN EST TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "EST TEST > HWND render target x DC render target (do GDI)");
	test6();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "ZAN SEDM TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "SEDM TEST > GDI x GDI kompatibiln render target(z GDI do Direct2D)");
	test7();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "ZAN OSM TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "OSM TEST > renderovn textu");
	test8();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "ZAN DEVT TEST");
	Sleep(2000);
	SetWindowTextA(hStext, "DEVT TEST > renderovn textu, D2D pouze (SW/HW + antialiasing)");
	test9();
	RedrawWindow(m_hwnd, NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW);

	SetWindowTextA(hStext, "HOTOVO - TESTY KOMPLETN");
	Sleep(2000);
	string konecna = "ZOBRAZUJ SE VSLEDKY (GDI " + to_string(gdiPocet) + "x, GDI+ " + to_string(gdiplusPocet) + "x, D2D " + to_string(d2dPocet) + "x)";
	SetWindowTextA(hStext, konecna.c_str());
	zobrazVysledek = 1; // specialni promenna - ve WM_PAINT se vykonava IF ktery zobrazuje vysledky
	PostMessage(m_hwnd, testuj, 666, 0); // tyto dve funkce muze zastoupit rovnou RedrawWindow, jen pro zajimavost to mam takto pres synchronizaci
	WaitForSingleObject(hEvent, INFINITE); // pametova bariera, synchronizace

	// SafeRelease(&m_pD2DFactory); jen pro test jak to vycisti nakonec vsechnu pamet v GPU
	// pro opakovany test:
	//ShowWindow(hBstart, SW_SHOW);
	//ShowWindow(hList, SW_SHOW);

	return 0;
}


void test1()
{
	int gVysledek[100];
	int gpVysledek[100];
	int dVysledek[100];
	ULONG64 cgVysledek[100];
	ULONG64 cgpVysledek[100];
	ULONG64 cdVysledek[100];

	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1SolidColorBrush *m_pBlackBrush = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawLine(D2D1::Point2F(10.0f, 50.0f), D2D1::Point2F(10.0f, 250.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawLine(D2D1::Point2F(20.0f, 50.0f), D2D1::Point2F(20.0f, 250.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawLine(D2D1::Point2F(30.0f, 50.0f), D2D1::Point2F(30.0f, 250.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawLine(D2D1::Point2F(40.0f, 50.0f), D2D1::Point2F(40.0f, 250.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawLine(D2D1::Point2F(50.0f, 50.0f), D2D1::Point2F(50.0f, 250.0f), m_pBlackBrush, 3.0);
			}
			// enddraw teprve vykona nacachovane prikazy k vykresleni(pokud je pred enddraw prikazu vic nez udrzi cache, tak se postupne vykonavaji i pred enddraw)
			hr = m_pHWNDRT->EndDraw();
			//m_pDCRT->Flush(); neni potreba, udela to enddraw metoda

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart);
			dVysledek[i] = celk;
			cdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pBlackBrush);
			SafeRelease(&m_pHWNDRT);
		}
	}
	
	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}


	for (int i = 0; i < 100; i++)
	{	
		HDC hdc = GetDC(m_hwnd);
		HGDIOBJ original = NULL; // Save the original object.
		HPEN blackPen = CreatePen(PS_SOLID, 3, 0);
		original = SelectObject(hdc, blackPen);

		POINT pntArray1[2];
		pntArray1[0].x = 70;
		pntArray1[0].y = 50;
		pntArray1[1].x = 70;
		pntArray1[1].y = 250;

		POINT pntArray2[2];
		pntArray2[0].x = 80;
		pntArray2[0].y = 50;
		pntArray2[1].x = 80;
		pntArray2[1].y = 250;

		POINT pntArray3[2];
		pntArray3[0].x = 90;
		pntArray3[0].y = 50;
		pntArray3[1].x = 90;
		pntArray3[1].y = 250;

		POINT pntArray4[2];
		pntArray4[0].x = 100;
		pntArray4[0].y = 50;
		pntArray4[1].x = 100;
		pntArray4[1].y = 250;

		POINT pntArray5[2];
		pntArray5[0].x = 110;
		pntArray5[0].y = 50;
		pntArray5[1].x = 110;
		pntArray5[1].y = 250;

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		GdiFlush();
		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiPocet; i++)
		{
			Polyline(hdc, pntArray1, 2);
			Polyline(hdc, pntArray2, 2);
			Polyline(hdc, pntArray3, 2);
			Polyline(hdc, pntArray4, 2);
			Polyline(hdc, pntArray5, 2);
		}
		GdiFlush(); // aby se vsechny cekajici prikazy vykonaly - pro jistotu volame
		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);

		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart);
		gVysledek[i] = celk;
		cgVysledek[i] = konec - start;

		SelectObject(hdc, original);
		DeleteObject(blackPen);
		ReleaseDC(m_hwnd, hdc);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		Graphics graphics(hdc);
		Pen pen(Color(255, 0, 0, 0), 3.0f);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		//graphics.Flush(FlushIntentionSync);

		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);	
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiplusPocet; i++)
		{
			graphics.DrawLine(&pen, 130, 50, 130, 250);
			graphics.DrawLine(&pen, 140, 50, 140, 250);
			graphics.DrawLine(&pen, 150, 50, 150, 250);
			graphics.DrawLine(&pen, 160, 50, 160, 250);
			graphics.DrawLine(&pen, 170, 50, 170, 250);
		}
		
		// POZOR ALE FlushIntentionSync PRIDAVA K CASU VZDYZ cca 16ms(+ skutecny cas operace=zaokrouhleno na nasobky 16ms)
		// jakozto VSYNC monitoru - neda se to vypnout jako u direct2d atd..
		// takze u GDI+ nedelat FLUSH, presto se to zprumeruje spravne - kdyz jsem delal pokusy, tak to bez FLUSH bylo spravne
		//graphics.Flush(FlushIntentionSync); // aby se vsechny cekajici prikazy vykonaly IHNED (FlushIntentionSync)
		
		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);
		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart);
		// implicitni konverze na INT z LONG LONG je tady bezpecna, protoze by musel kod bezet vic jak 60minut, coz se nestane, pripadne by slo overovat jestli kod bezi prilis dlohou test by se neprovedl atd.. i tak by to neznicilo aplikaci, jen by to ukazalo pretoceny cas odznovu..
		gpVysledek[i] = celk;
		cgpVysledek[i] = konec - start;

		ReleaseDC(m_hwnd, hdc);
	}


	// vypocet aritmetickeho prumeru a variacniho koeficientu - z duvodu presnosti beru pouze polovinu hodnot z prostredka
	double vgVysledek = 0;
	double vgpVysledek = 0;
	double vdVysledek = 0;
	for (int i = 25; i < 75; i++)
	{
		gTest1 += gVysledek[i];
		gpTest1 += gpVysledek[i];
		dTest1 += dVysledek[i];
		cgTest1 += cgVysledek[i];
		cgpTest1 += cgpVysledek[i];
		cdTest1 += cdVysledek[i];
		vgVysledek += (double)(gVysledek[i]) * (double)(gVysledek[i]);
		vgpVysledek += (double)(gpVysledek[i]) * (double)(gpVysledek[i]);
		vdVysledek += (double)(dVysledek[i]) * (double)(dVysledek[i]);
	}

	gTest1 = gTest1 / 50;
	gpTest1 = gpTest1 / 50;
	dTest1 = dTest1 / 50;
	cgTest1 = cgTest1 / 50;
	cgpTest1 = cgpTest1 / 50;
	cdTest1 = cdTest1 / 50;
	vgTest1 = sqrt((vgVysledek / 50) - ((double)gTest1 * (double)gTest1));
	vgTest1 = (vgTest1 / gTest1) * 100;
	vgpTest1 = sqrt((vgpVysledek / 50) - ((double)gpTest1 * (double)gpTest1));
	vgpTest1 = (vgpTest1 / gpTest1) * 100;
	vdTest1 = sqrt((vdVysledek / 50) - ((double)dTest1 * (double)dTest1));
	vdTest1 = (vdTest1 / dTest1) * 100;
}

void test2()
{

	int gVysledek[100];
	int gpVysledek[100];
	int dVysledek[100];
	ULONG64 cgVysledek[100];
	ULONG64 cgpVysledek[100];
	ULONG64 cdVysledek[100];

	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1SolidColorBrush *m_pBlackBrush = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(150.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(300.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(450.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
			}
			// enddraw teprve vykona nacachovane prikazy k vykresleni(pokud je pred enddraw prikazu vic nez udrzi cache, tak se postupne vykonavaji i pred enddraw)
			hr = m_pHWNDRT->EndDraw();
			//m_pDCRT->Flush(); neni potreba, udela to enddraw metoda

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			dVysledek[i] = celk;
			cdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		HPEN blackPen = CreatePen(PS_SOLID, 3, 0);
		HGDIOBJ original = SelectObject(hdc, blackPen);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		GdiFlush();
		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiPocet; i++)
		{
			Ellipse(hdc, 90, 250, 210, 370);
			Ellipse(hdc, 240, 250, 360, 370);
			Ellipse(hdc, 390, 250, 510, 370);
		}
		GdiFlush(); // aby se vsechny cekajici prikazy vykonaly - pro jistotu volame
		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);

		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gVysledek[i] = celk;
		cgVysledek[i] = konec - start;

		SelectObject(hdc, original);
		DeleteObject(blackPen);
		ReleaseDC(m_hwnd, hdc);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		Graphics graphics(hdc);
		Pen pen(Color(255, 0, 0, 0), 3.0f);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiplusPocet; i++)
		{
			graphics.DrawEllipse(&pen, 90, 400, 120, 120);
			graphics.DrawEllipse(&pen, 240, 400, 120, 120);
			graphics.DrawEllipse(&pen, 390, 400, 120, 120);
		}

		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);
		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gpVysledek[i] = celk;
		cgpVysledek[i] = konec - start;

		ReleaseDC(m_hwnd, hdc);
	}


	double vgVysledek = 0;
	double vgpVysledek = 0;
	double vdVysledek = 0;
	for (int i = 25; i < 75; i++)
	{
		gTest2 += gVysledek[i];
		gpTest2 += gpVysledek[i];
		dTest2 += dVysledek[i];
		cgTest2 += cgVysledek[i];
		cgpTest2 += cgpVysledek[i];
		cdTest2 += cdVysledek[i];
		vgVysledek += (double)(gVysledek[i]) * (double)(gVysledek[i]);
		vgpVysledek += (double)(gpVysledek[i]) * (double)(gpVysledek[i]);
		vdVysledek += (double)(dVysledek[i]) * (double)(dVysledek[i]);
	}

	gTest2 = gTest2 / 50;
	gpTest2 = gpTest2 / 50;
	dTest2 = dTest2 / 50;
	cgTest2 = cgTest2 / 50;
	cgpTest2 = cgpTest2 / 50;
	cdTest2 = cdTest2 / 50;
	vgTest2 = sqrt((vgVysledek / 50) - ((double)gTest2 * (double)gTest2));
	vgTest2 = (vgTest2 / gTest2) * 100;
	vgpTest2 = sqrt((vgpVysledek / 50) - ((double)gpTest2 * (double)gpTest2));
	vgpTest2 = (vgpTest2 / gpTest2) * 100;
	vdTest2 = sqrt((vdVysledek / 50) - ((double)dTest2 * (double)dTest2));
	vdTest2 = (vdTest2 / dTest2) * 100;
}


void test3()
{

	int swdVysledek[100];
	int swadVysledek[100];
	int hwadVysledek[100];
	ULONG64 cswdVysledek[100];
	ULONG64 cswadVysledek[100];
	ULONG64 chwadVysledek[100];

	ID2D1SolidColorBrush *m_pBlackBrush = NULL;
	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_SOFTWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(150.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(300.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(450.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
			}
			// enddraw teprve vykona nacachovane prikazy k vykresleni(pokud je pred enddraw prikazu vic nez udrzi cache, tak se postupne vykonavaji i pred enddraw)
			hr = m_pHWNDRT->EndDraw();
			//m_pDCRT->Flush(); neni potreba, udela to enddraw metoda

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			swdVysledek[i] = celk;
			cswdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}



	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_SOFTWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_PER_PRIMITIVE);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(150.0f, 250.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(300.0f, 250.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(450.0f, 250.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
			}
			// enddraw teprve vykona nacachovane prikazy k vykresleni(pokud je pred enddraw prikazu vic nez udrzi cache, tak se postupne vykonavaji i pred enddraw)
			hr = m_pHWNDRT->EndDraw();
			//m_pDCRT->Flush(); neni potreba, udela to enddraw metoda

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			swadVysledek[i] = celk;
			cswadVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}


	
	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_PER_PRIMITIVE);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(150.0f, 350.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(300.0f, 350.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pHWNDRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(450.0f, 350.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
			}
			// enddraw teprve vykona nacachovane prikazy k vykresleni(pokud je pred enddraw prikazu vic nez udrzi cache, tak se postupne vykonavaji i pred enddraw)
			hr = m_pHWNDRT->EndDraw();
			//m_pDCRT->Flush(); neni potreba, udela to enddraw metoda

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			hwadVysledek[i] = celk;
			chwadVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}


	double vswdVysledek = 0;
	double vswadVysledek = 0;
	double vhwadVysledek = 0;

	for (int i = 25; i < 75; i++)
	{
		swdTest3 += swdVysledek[i];
		swadTest3 += swadVysledek[i];
		hwadTest3 += hwadVysledek[i];
		cswdTest3 += cswdVysledek[i];
		cswadTest3 += cswadVysledek[i];
		chwadTest3 += chwadVysledek[i];
		vswdVysledek += (double)(swdVysledek[i]) * (double)(swdVysledek[i]);
		vswadVysledek += (double)(swadVysledek[i]) * (double)(swadVysledek[i]);
		vhwadVysledek += (double)(hwadVysledek[i]) * (double)(hwadVysledek[i]);
	}

	swdTest3 = swdTest3 / 50;
	swadTest3 = swadTest3 / 50;
	hwadTest3 = hwadTest3 / 50;
	cswdTest3 = cswdTest3 / 50;
	cswadTest3 = cswadTest3 / 50;
	chwadTest3 = chwadTest3 / 50;
	vswdTest3 = sqrt((vswdVysledek / 50) - ((double)swdTest3 * (double)swdTest3));
	vswdTest3 = (vswdTest3 / swdTest3) * 100;
	vswadTest3 = sqrt((vswadVysledek / 50) - ((double)swadTest3 * (double)swadTest3));
	vswadTest3 = (vswadTest3 / swadTest3) * 100;
	vhwadTest3 = sqrt((vhwadVysledek / 50) - ((double)hwadTest3 * (double)hwadTest3));
	vhwadTest3 = (vhwadTest3 / hwadTest3) * 100;
}

void test4()
{
	int gVysledek[100];
	int gpVysledek[100];
	int dVysledek[100];
	ULONG64 cgVysledek[100];
	ULONG64 cgpVysledek[100];
	ULONG64 cdVysledek[100];

	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1BitmapRenderTarget *m_pBMPRT = NULL;
	ID2D1SolidColorBrush *m_pBlackBrush = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
		}
			
		if (SUCCEEDED(hr))
		{
			if (!m_pBlackBrush)
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}
		
		if (SUCCEEDED(hr))
		{	
			if (!m_pBMPRT)
			{
				hr = m_pHWNDRT->CreateCompatibleRenderTarget(&m_pBMPRT);
			}
		}
		
		if (SUCCEEDED(hr))
		{
			m_pBMPRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pBMPRT->BeginDraw();
			m_pBMPRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pBMPRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pBMPRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(150.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pBMPRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(300.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
				m_pBMPRT->DrawEllipse(D2D1::Ellipse(D2D1::Point2F(450.0f, 150.0f), 60.0f, 60.0f), m_pBlackBrush, 3.0);
			}
			hr = m_pBMPRT->EndDraw();

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			dVysledek[i] = celk;
			cdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pBlackBrush);
			SafeRelease(&m_pBMPRT);
			SafeRelease(&m_pHWNDRT);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pBlackBrush);
		SafeRelease(&m_pBMPRT);
		SafeRelease(&m_pHWNDRT);
	}



	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		HPEN blackPen = CreatePen(PS_SOLID, 3, 0);
		HDC memDC = CreateCompatibleDC(hdc);
		RECT rc;
		GetClientRect(m_hwnd, &rc);
		HBITMAP memBM = CreateCompatibleBitmap(hdc, rc.right - rc.left, rc.bottom - rc.top);
		HGDIOBJ oldmemBM = SelectObject(memDC, memBM);
		HGDIOBJ original = SelectObject(memDC, blackPen);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		GdiFlush();
		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiPocet; i++)
		{
			Ellipse(memDC, 90, 250, 210, 370);
			Ellipse(memDC, 240, 250, 360, 370);
			Ellipse(memDC, 390, 250, 510, 370);
		}
		GdiFlush(); // aby se vsechny cekajici prikazy vykonaly - pro jistotu volame
		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);

		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gVysledek[i] = celk;
		cgVysledek[i] = konec - start;
		
		SelectObject(memDC, original);
		DeleteObject(blackPen);
		SelectObject(memDC, oldmemBM);
		DeleteObject(memBM);
		DeleteDC(memDC);
		ReleaseDC(m_hwnd, hdc);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		HDC memDC = CreateCompatibleDC(hdc);
		RECT rc;
		GetClientRect(m_hwnd, &rc);
		HBITMAP memBM = CreateCompatibleBitmap(hdc, rc.right - rc.left, rc.bottom - rc.top);
		HGDIOBJ oldmemBM = SelectObject(memDC, memBM);

		Graphics graphics(memDC);
		Pen pen(Color(255, 0, 0, 0), 3.0f);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiplusPocet; i++)
		{
			graphics.DrawEllipse(&pen, 90, 400, 120, 120);
			graphics.DrawEllipse(&pen, 240, 400, 120, 120);
			graphics.DrawEllipse(&pen, 390, 400, 120, 120);
		}

		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);
		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gpVysledek[i] = celk;
		cgpVysledek[i] = konec - start;
		
		SelectObject(memDC, oldmemBM);
		DeleteObject(memBM);
		DeleteDC(memDC);
		ReleaseDC(m_hwnd, hdc);
	}


	double vgVysledek = 0;
	double vgpVysledek = 0;
	double vdVysledek = 0;

	for (int i = 25; i < 75; i++)
	{
		gTest4 += gVysledek[i];
		gpTest4 += gpVysledek[i];
		dTest4 += dVysledek[i];
		cgTest4 += cgVysledek[i];
		cgpTest4 += cgpVysledek[i];
		cdTest4 += cdVysledek[i];
		vgVysledek += (double)(gVysledek[i]) * (double)(gVysledek[i]);
		vgpVysledek += (double)(gpVysledek[i]) * (double)(gpVysledek[i]);
		vdVysledek += (double)(dVysledek[i]) * (double)(dVysledek[i]);
	}

	gTest4 = gTest4 / 50;
	gpTest4 = gpTest4 / 50;
	dTest4 = dTest4 / 50;
	cgTest4 = cgTest4 / 50;
	cgpTest4 = cgpTest4 / 50;
	cdTest4 = cdTest4 / 50;
	vgTest4 = sqrt((vgVysledek / 50) - ((double)gTest4 * (double)gTest4));
	vgTest4 = (vgTest4 / gTest4) * 100;
	vgpTest4 = sqrt((vgpVysledek / 50) - ((double)gpTest4 * (double)gpTest4));
	vgpTest4 = (vgpTest4 / gpTest4) * 100;
	vdTest4 = sqrt((vdVysledek / 50) - ((double)dTest4 * (double)dTest4));
	vdTest4 = (vdTest4 / dTest4) * 100;

}


void test5()
{

	int gVysledek[100];
	int gpVysledek[100];
	int dVysledek[100];
	ULONG64 cgVysledek[100];
	ULONG64 cgpVysledek[100];
	ULONG64 cdVysledek[100];


	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1Bitmap *ppBitmap = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
		}

		if (!ppBitmap)
		{
			// inicializace COM
			CoInitialize(NULL);

			IWICImagingFactory *pIWICFactory = NULL;

			// tvorba COM WIC tovarny
			hr = CoCreateInstance(
				CLSID_WICImagingFactory,
				NULL,
				CLSCTX_INPROC_SERVER,
				IID_PPV_ARGS(&pIWICFactory)
				);

			IWICBitmapDecoder *pDecoder = NULL;
			IWICBitmapFrameDecode *pSource = NULL;
			IWICFormatConverter *pConverter = NULL;

			hr = pIWICFactory->CreateDecoderFromFilename(
				L"obrazek.bmp",
				NULL,
				GENERIC_READ,
				WICDecodeMetadataCacheOnLoad,
				&pDecoder
				);

			if (SUCCEEDED(hr))
			{
				// ziskani snimku.. jpg, bmp atd. ma pouze 1 snimek tj. nulty index (prvni)
				hr = pDecoder->GetFrame(0, &pSource);
			}

			if (SUCCEEDED(hr))
			{
				// Convert the image format to 32bppPBGRA
				// (DXGI_FORMAT_B8G8R8A8_UNORM + D2D1_ALPHA_MODE_PREMULTIPLIED).
				// GUID_WICPixelFormat32bppBGRA is only supported in Windows 8, the Platform Update for Windows 7, and above.
				// takze se musi vytvorit render target s timto nastavenim pokud ma podporovat alpha kanal
				hr = pIWICFactory->CreateFormatConverter(&pConverter);
			}

			if (SUCCEEDED(hr))
			{
				hr = pConverter->Initialize(
					pSource,
					GUID_WICPixelFormat32bppBGR,
					WICBitmapDitherTypeNone,
					NULL,
					0.f,
					WICBitmapPaletteTypeMedianCut
					);
			}

			if (SUCCEEDED(hr))
			{
				// tvorba D2D bitmapy z WIC bitmapy
				hr = m_pHWNDRT->CreateBitmapFromWicBitmap(
					pConverter,
					NULL,
					&ppBitmap
					);
			}

			SafeRelease(&pDecoder);
			SafeRelease(&pSource);
			SafeRelease(&pConverter);
			SafeRelease(&pIWICFactory);
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->BeginDraw();
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			D2D1_SIZE_F size = ppBitmap->GetSize();
			D2D1_POINT_2F upperLeftCorner = D2D1::Point2F(100.f, 50.f);

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawBitmap(
					ppBitmap,
					D2D1::RectF(
					upperLeftCorner.x,
					upperLeftCorner.y,
					upperLeftCorner.x + size.width,
					upperLeftCorner.y + size.height)
					);
			}
			hr = m_pHWNDRT->EndDraw();
			
			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			dVysledek[i] = celk;
			cdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&ppBitmap);
			SafeRelease(&m_pHWNDRT);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&ppBitmap);
		SafeRelease(&m_pHWNDRT);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);

		HBITMAP bmpSource = (HBITMAP)LoadImage(NULL, L"obrazek.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		HDC bmpHDC = CreateCompatibleDC(hdc);
		HGDIOBJ oldmemBM = SelectObject(bmpHDC, bmpSource);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		GdiFlush();
		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiPocet; i++)
		{
			BitBlt(hdc, 100, 250, 300, 187, bmpHDC, 0, 0, SRCCOPY);
		}
		GdiFlush(); // aby se vsechny cekajici prikazy vykonaly - pro jistotu volame
		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);

		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gVysledek[i] = celk;
		cgVysledek[i] = konec - start;

		SelectObject(bmpHDC, oldmemBM);
		DeleteObject(bmpSource);
		DeleteDC(bmpHDC);
		ReleaseDC(m_hwnd, hdc);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		Graphics graphics(hdc);

		// toto je dynamicka pamet FromFile vola zrejme uvnitr new a proto je potreba volat delete na konci pouziti
		Bitmap *bitmapa = Bitmap::FromFile(L"obrazek.bmp");
		
		//graphics.SetSmoothingMode(Gdiplus::SmoothingMode::SmoothingModeHighQuality);
		//graphics.SetCompositingMode(Gdiplus::CompositingModeSourceCopy);
		//graphics.SetInterpolationMode(Gdiplus::InterpolationModeHighQuality);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiplusPocet; i++)
		{
			graphics.DrawImage(bitmapa, 450, 50, bitmapa->GetWidth(), bitmapa->GetHeight());
		}

		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);
		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gpVysledek[i] = celk;
		cgpVysledek[i] = konec - start;

		delete bitmapa;
		ReleaseDC(m_hwnd, hdc);
	}

	double vgVysledek = 0;
	double vgpVysledek = 0;
	double vdVysledek = 0;

	for (int i = 25; i < 75; i++)
	{
		gTest5 += gVysledek[i];
		gpTest5 += gpVysledek[i];
		dTest5 += dVysledek[i];
		cgTest5 += cgVysledek[i];
		cgpTest5 += cgpVysledek[i];
		cdTest5 += cdVysledek[i];
		vgVysledek += (double)(gVysledek[i]) * (double)(gVysledek[i]);
		vgpVysledek += (double)(gpVysledek[i]) * (double)(gpVysledek[i]);
		vdVysledek += (double)(dVysledek[i]) * (double)(dVysledek[i]);
	}

	gTest5 = gTest5 / 50;
	gpTest5 = gpTest5 / 50;
	dTest5 = dTest5 / 50;
	cgTest5 = cgTest5 / 50;
	cgpTest5 = cgpTest5 / 50;
	cdTest5 = cdTest5 / 50;
	vgTest5 = sqrt((vgVysledek / 50) - ((double)gTest5 * (double)gTest5));
	vgTest5 = (vgTest5 / gTest5) * 100;
	vgpTest5 = sqrt((vgpVysledek / 50) - ((double)gpTest5 * (double)gpTest5));
	vgpTest5 = (vgpTest5 / gpTest5) * 100;
	vdTest5 = sqrt((vdVysledek / 50) - ((double)dTest5 * (double)dTest5));
	vdTest5 = (vdTest5 / dTest5) * 100;
}


void test6()
{
	int dVysledek[100];
	int dcdVysledek[100];
	ULONG64 cdVysledek[100];
	ULONG64 cdcdVysledek[100];

	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1SolidColorBrush *m_pBlackBrush = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->BeginDraw();
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			D2D1_RECT_F rectangle1 = D2D1::RectF(150.0f, 150.0f, 450.0f, 450.0f);
			D2D1_RECT_F rectangle2 = D2D1::RectF(180.0f, 180.0f, 420.0f, 420.0f);
			D2D1_RECT_F rectangle3 = D2D1::RectF(230.0f,230.0f, 370.0f, 370.0f);

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawRectangle(&rectangle1, m_pBlackBrush, 3.0f);
				m_pHWNDRT->DrawRectangle(&rectangle2, m_pBlackBrush, 3.0f);
				m_pHWNDRT->DrawRectangle(&rectangle3, m_pBlackBrush, 3.0f);
			}
			
			hr = m_pHWNDRT->EndDraw();

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			dVysledek[i] = celk;
			cdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pBlackBrush);
			SafeRelease(&m_pHWNDRT);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}



	ID2D1DCRenderTarget *m_pDCRT = NULL;
	HDC hdc = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pDCRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			hr = m_pD2DFactory->CreateDCRenderTarget(&props, &m_pDCRT);
			
			if (SUCCEEDED(hr))
			{
				RECT rc;
				GetClientRect(m_hwnd, &rc);
				hdc = GetDC(m_hwnd);
				hr = m_pDCRT->BindDC(hdc, &rc);
			}

			if (SUCCEEDED(hr))
			{
				hr = m_pDCRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pDCRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pDCRT->BeginDraw();
			m_pDCRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pDCRT->Clear(D2D1::ColorF(D2D1::ColorF::White));

			D2D1_RECT_F rectangle1 = D2D1::RectF(470.0f, 150.0f, 770.0f, 450.0f);
			D2D1_RECT_F rectangle2 = D2D1::RectF(500.0f, 180.0f, 740.0f, 420.0f);
			D2D1_RECT_F rectangle3 = D2D1::RectF(550.0f, 230.0f, 690.0f, 370.0f);

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pDCRT->DrawRectangle(&rectangle1, m_pBlackBrush, 3.0f);
				m_pDCRT->DrawRectangle(&rectangle2, m_pBlackBrush, 3.0f);
				m_pDCRT->DrawRectangle(&rectangle3, m_pBlackBrush, 3.0f);
			}

			hr = m_pDCRT->EndDraw();

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			dcdVysledek[i] = celk;
			cdcdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pBlackBrush);
			SafeRelease(&m_pDCRT);
			ReleaseDC(m_hwnd, hdc);
		}
	}

	if (m_pHWNDRT)
	{	
		SafeRelease(&m_pBlackBrush);
		SafeRelease(&m_pDCRT);
		ReleaseDC(m_hwnd, hdc);
	}


	double vdVysledek = 0;
	double vdcdVysledek = 0;

	for (int i = 25; i < 75; i++)
	{
		dTest6 += dVysledek[i];
		dcdTest6 += dcdVysledek[i];
		cdTest6 += cdVysledek[i];
		cdcdTest6 += cdcdVysledek[i];
		vdVysledek += (double)(dVysledek[i]) * (double)(dVysledek[i]);
		vdcdVysledek += (double)(dcdVysledek[i]) * (double)(dcdVysledek[i]);
	}

	dTest6 = dTest6 / 50;
	dcdTest6 = dcdTest6 / 50;
	cdTest6 = cdTest6 / 50;
	cdcdTest6 = cdcdTest6 / 50;
	vdTest6 = sqrt((vdVysledek / 50) - ((double)dTest6 * (double)dTest6));
	vdTest6 = (vdTest6 / dTest6) * 100;
	vdcdTest6 = sqrt((vdcdVysledek / 50) - ((double)dcdTest6 * (double)dcdTest6));
	vdcdTest6 = (vdcdTest6 / dcdTest6) * 100;
}




void test7()
{
	int gVysledek[100];
	int gdidVysledek[100];
	ULONG64 cgVysledek[100];
	ULONG64 cgdidVysledek[100];


	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1GdiInteropRenderTarget *m_pGDIRT = NULL;
	HDC hDC = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_GDI_COMPATIBLE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->QueryInterface(__uuidof(ID2D1GdiInteropRenderTarget), (void**)&m_pGDIRT);
			}	
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->BeginDraw();
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White)); 
			hr = m_pGDIRT->GetDC(D2D1_DC_INITIALIZE_MODE_COPY, &hDC);

			if (SUCCEEDED(hr))
			{
				HPEN blackPen = CreatePen(PS_SOLID, 3, 0);
				HGDIOBJ original = SelectObject(hDC, blackPen);

				LARGE_INTEGER qpc;
				LARGE_INTEGER qpc2;
				LARGE_INTEGER qpcf;
				ULONG64 start, konec;

				GdiFlush();

				QueryPerformanceFrequency(&qpcf);
				QueryPerformanceCounter(&qpc);
				QueryThreadCycleTime(hThread, &start);

				for (int i = 0; i < gdiPocet; i++)
				{
					Rectangle(hDC, 150, 150, 450, 450);
					Rectangle(hDC, 180, 180, 420, 420);
					Rectangle(hDC, 230, 230, 370, 370);
				}

				GdiFlush();

				QueryThreadCycleTime(hThread, &konec);
				QueryPerformanceCounter(&qpc2);
				long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
				gdidVysledek[i] = celk;
				cgdidVysledek[i] = konec - start;


				SelectObject(hDC, original);
				DeleteObject(blackPen);
			}

			m_pGDIRT->ReleaseDC(NULL);
			m_pHWNDRT->EndDraw();

		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pGDIRT);
			SafeRelease(&m_pHWNDRT);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pGDIRT);
		SafeRelease(&m_pHWNDRT);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		HPEN blackPen = CreatePen(PS_SOLID, 3, 0);
		HGDIOBJ original = SelectObject(hdc, blackPen);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		GdiFlush();
		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiPocet; i++)
		{
			Rectangle(hdc, 470, 150, 770, 450);
			Rectangle(hdc, 500, 180, 740, 420);
			Rectangle(hdc, 550, 230, 690, 370);
		}
		GdiFlush();
		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);

		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gVysledek[i] = celk;
		cgVysledek[i] = konec - start;

		SelectObject(hdc, original);
		DeleteObject(blackPen);
		ReleaseDC(m_hwnd, hdc);
	}


	double vgVysledek = 0;
	double vgdidVysledek = 0;

	for (int i = 25; i < 75; i++)
	{
		gTest7 += gVysledek[i];
		gdidTest7 += gdidVysledek[i];
		cgTest7 += cgVysledek[i];
		cgdidTest7 += cgdidVysledek[i];
		vgVysledek += (double)(gVysledek[i]) * (double)(gVysledek[i]);
		vgdidVysledek += (double)(gdidVysledek[i]) * (double)(gdidVysledek[i]);
	}

	gTest7 = gTest7 / 50;
	gdidTest7 = gdidTest7 / 50;
	cgTest7 = cgTest7 / 50;
	cgdidTest7 = cgdidTest7 / 50;
	vgTest7 = sqrt((vgVysledek / 50) - ((double)gTest7 * (double)gTest7));
	vgTest7 = (vgTest7 / gTest7) * 100;
	vgdidTest7 = sqrt((vgdidVysledek / 50) - ((double)gdidTest7 * (double)gdidTest7));
	vgdidTest7 = (vgdidTest7 / gdidTest7) * 100;
}


void test8()
{

	int gVysledek[100];
	int gpVysledek[100];
	int dVysledek[100];
	ULONG64 cgVysledek[100];
	ULONG64 cgpVysledek[100];
	ULONG64 cdVysledek[100];

	// typicka ceska testovaci veta na diakritiku
	const WCHAR sc_helloWorld[] = L", nhl d隝 ji zvil prach a il la te b s houfcem gazel k krytm.";
	
	const WCHAR msc_fontName[] = L"Arial";
	const FLOAT msc_fontSize = 25;
	HRESULT hr;

	IDWriteFactory *m_pDWriteFactory = NULL;
	// pokud se vytvori SHARED misto ISOLATED, tak sice sdili resources, ale casove je mnooohem narocnejsi na psani textu
	hr = DWriteCreateFactory(DWRITE_FACTORY_TYPE_ISOLATED, __uuidof(m_pDWriteFactory), reinterpret_cast<IUnknown **>(&m_pDWriteFactory));

	IDWriteTextFormat *m_pTextFormat = NULL;

	if (SUCCEEDED(hr))
	{
		hr = m_pDWriteFactory->CreateTextFormat(
			msc_fontName,
			NULL,
			DWRITE_FONT_WEIGHT_EXTRA_LIGHT,
			DWRITE_FONT_STYLE_NORMAL,
			DWRITE_FONT_STRETCH_NORMAL,
			msc_fontSize,
			L"", //locale
			&m_pTextFormat
			);
	}

	if (SUCCEEDED(hr))
	{
		// centrovani textu horizontalne a vertikalne
		//m_pTextFormat->SetTextAlignment(DWRITE_TEXT_ALIGNMENT_CENTER);
		//m_pTextFormat->SetParagraphAlignment(DWRITE_PARAGRAPH_ALIGNMENT_CENTER);
	}


	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1SolidColorBrush *m_pBlackBrush = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);
			
			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->SetTextAntialiasMode(D2D1_TEXT_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));
			D2D1_SIZE_F renderTargetSize = m_pHWNDRT->GetSize();
			
			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawText(
					sc_helloWorld,
					ARRAYSIZE(sc_helloWorld) - 1,
					m_pTextFormat,
					D2D1::RectF(100, 100, 1000, 180),
					m_pBlackBrush
					);
			}

			hr = m_pHWNDRT->EndDraw();

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			dVysledek[i] = celk;
			cdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}

	SafeRelease(&m_pTextFormat);
	SafeRelease(&m_pDWriteFactory);


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		HFONT hFont = CreateFontW(30, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS,
			CLIP_DEFAULT_PRECIS, NONANTIALIASED_QUALITY, DEFAULT_PITCH, L"Arial");
		SelectObject(hdc, hFont);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		GdiFlush();
		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiPocet; i++)
		{
			TextOutW(hdc, 100, 200, sc_helloWorld, ARRAYSIZE(sc_helloWorld) - 1);
		}
		GdiFlush(); // aby se vsechny cekajici prikazy vykonaly - pro jistotu volame
		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);

		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gVysledek[i] = celk;
		cgVysledek[i] = konec - start;

		DeleteObject(hFont);
		ReleaseDC(m_hwnd, hdc);
	}


	for (int i = 0; i < 100; i++)
	{
		HDC hdc = GetDC(m_hwnd);
		Graphics graphics(hdc);
		SolidBrush blackBrush(Color(255, 0, 0, 0));
		HFONT hFont = CreateFontW(30, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS,
			CLIP_DEFAULT_PRECIS, NONANTIALIASED_QUALITY, DEFAULT_PITCH, L"Arial");
		Font font(hdc, hFont);
		RectF rect(100.0f, 300.0f, 1000.0f, 400.0f);
		StringFormat format;
		graphics.SetTextRenderingHint(TextRenderingHintSystemDefault);

		LARGE_INTEGER qpc;
		LARGE_INTEGER qpc2;
		LARGE_INTEGER qpcf;
		ULONG64 start, konec;

		QueryPerformanceFrequency(&qpcf);
		QueryPerformanceCounter(&qpc);
		QueryThreadCycleTime(hThread, &start);

		for (int i = 0; i < gdiplusPocet; i++)
		{
			graphics.DrawString(sc_helloWorld, ARRAYSIZE(sc_helloWorld)-1, &font, rect, &format, &blackBrush);
		}

		QueryThreadCycleTime(hThread, &konec);
		QueryPerformanceCounter(&qpc2);
		long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
		gpVysledek[i] = celk;
		cgpVysledek[i] = konec - start;

		ReleaseDC(m_hwnd, hdc);
	}


	double vgVysledek = 0;
	double vgpVysledek = 0;
	double vdVysledek = 0;
	for (int i = 25; i < 75; i++)
	{
		gTest8 += gVysledek[i];
		gpTest8 += gpVysledek[i];
		dTest8 += dVysledek[i];
		cgTest8 += cgVysledek[i];
		cgpTest8 += cgpVysledek[i];
		cdTest8 += cdVysledek[i];
		vgVysledek += (double)(gVysledek[i]) * (double)(gVysledek[i]);
		vgpVysledek += (double)(gpVysledek[i]) * (double)(gpVysledek[i]);
		vdVysledek += (double)(dVysledek[i]) * (double)(dVysledek[i]);
	}

	gTest8 = gTest8 / 50;
	gpTest8 = gpTest8 / 50;
	dTest8 = dTest8 / 50;
	cgTest8 = cgTest8 / 50;
	cgpTest8 = cgpTest8 / 50;
	cdTest8 = cdTest8 / 50;
	vgTest8 = sqrt((vgVysledek / 50) - ((double)gTest8 * (double)gTest8));
	vgTest8 = (vgTest8 / gTest8) * 100;
	vgpTest8 = sqrt((vgpVysledek / 50) - ((double)gpTest8 * (double)gpTest8));
	vgpTest8 = (vgpTest8 / gpTest8) * 100;
	vdTest8 = sqrt((vdVysledek / 50) - ((double)dTest8 * (double)dTest8));
	vdTest8 = (vdTest8 / dTest8) * 100;

}


void test9()
{
	int swdVysledek[100];
	int swadVysledek[100];
	int hwadVysledek[100];
	ULONG64 cswdVysledek[100];
	ULONG64 cswadVysledek[100];
	ULONG64 chwadVysledek[100];


	const WCHAR sc_helloWorld[] = L", nhl d隝 ji zvil prach a il la te b s houfcem gazel k krytm.";

	const WCHAR msc_fontName[] = L"Arial";
	const FLOAT msc_fontSize = 25;
	HRESULT hr;

	IDWriteFactory *m_pDWriteFactory = NULL;
	hr = DWriteCreateFactory(DWRITE_FACTORY_TYPE_ISOLATED, __uuidof(m_pDWriteFactory), reinterpret_cast<IUnknown **>(&m_pDWriteFactory));

	IDWriteTextFormat *m_pTextFormat = NULL;

	if (SUCCEEDED(hr))
	{
		hr = m_pDWriteFactory->CreateTextFormat(
			msc_fontName,
			NULL,
			DWRITE_FONT_WEIGHT_EXTRA_LIGHT,
			DWRITE_FONT_STYLE_NORMAL,
			DWRITE_FONT_STRETCH_NORMAL,
			msc_fontSize,
			L"", //locale
			&m_pTextFormat
			);
	}

	if (SUCCEEDED(hr))
	{
		// centrovani textu horizontalne a vertikalne
		//m_pTextFormat->SetTextAlignment(DWRITE_TEXT_ALIGNMENT_CENTER);
		//m_pTextFormat->SetParagraphAlignment(DWRITE_PARAGRAPH_ALIGNMENT_CENTER);
	}


	ID2D1HwndRenderTarget *m_pHWNDRT = NULL;
	ID2D1SolidColorBrush *m_pBlackBrush = NULL;

	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_SOFTWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);

			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->SetTextAntialiasMode(D2D1_TEXT_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));
			D2D1_SIZE_F renderTargetSize = m_pHWNDRT->GetSize();

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawText(
					sc_helloWorld,
					ARRAYSIZE(sc_helloWorld) - 1,
					m_pTextFormat,
					D2D1::RectF(100, 100, 1000, 180),
					m_pBlackBrush
					);
			}

			hr = m_pHWNDRT->EndDraw();

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			swdVysledek[i] = celk;
			cswdVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}

	SafeRelease(&m_pTextFormat);
	SafeRelease(&m_pDWriteFactory);




	hr = DWriteCreateFactory(DWRITE_FACTORY_TYPE_ISOLATED, __uuidof(m_pDWriteFactory), reinterpret_cast<IUnknown **>(&m_pDWriteFactory));


	if (SUCCEEDED(hr))
	{
		hr = m_pDWriteFactory->CreateTextFormat(
			msc_fontName,
			NULL,
			DWRITE_FONT_WEIGHT_EXTRA_LIGHT,
			DWRITE_FONT_STYLE_NORMAL,
			DWRITE_FONT_STRETCH_NORMAL,
			msc_fontSize,
			L"", //locale
			&m_pTextFormat
			);
	}


	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_SOFTWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);

			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->SetTextAntialiasMode(D2D1_TEXT_ANTIALIAS_MODE_CLEARTYPE);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));
			D2D1_SIZE_F renderTargetSize = m_pHWNDRT->GetSize();

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawText(
					sc_helloWorld,
					ARRAYSIZE(sc_helloWorld) - 1,
					m_pTextFormat,
					D2D1::RectF(100, 200, 1000, 280),
					m_pBlackBrush
					);
			}

			hr = m_pHWNDRT->EndDraw();

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			swadVysledek[i] = celk;
			cswadVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}

	SafeRelease(&m_pTextFormat);
	SafeRelease(&m_pDWriteFactory);



	hr = DWriteCreateFactory(DWRITE_FACTORY_TYPE_ISOLATED, __uuidof(m_pDWriteFactory), reinterpret_cast<IUnknown **>(&m_pDWriteFactory));


	if (SUCCEEDED(hr))
	{
		hr = m_pDWriteFactory->CreateTextFormat(
			msc_fontName,
			NULL,
			DWRITE_FONT_WEIGHT_EXTRA_LIGHT,
			DWRITE_FONT_STYLE_NORMAL,
			DWRITE_FONT_STRETCH_NORMAL,
			msc_fontSize,
			L"", //locale
			&m_pTextFormat
			);
	}


	for (int i = 0; i < 100; i++)
	{

		HRESULT hr = S_OK;

		if (!m_pHWNDRT)
		{
			D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
				// lze misto default dat HARDWARE nebo SOFTWARE rendering (DEFAULT =  samo zvoli fungujici)
				D2D1_RENDER_TARGET_TYPE_HARDWARE,
				D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE),
				0,
				0,
				D2D1_RENDER_TARGET_USAGE_NONE,
				// lze nastavit jaky feature level (directx verzi) ma primo podporovat (DEFAULT = samo zvoli nejlepsi)
				D2D1_FEATURE_LEVEL_DEFAULT
				);

			RECT rc;
			GetClientRect(m_hwnd, &rc);
			D2D1_SIZE_U size = D2D1::SizeU(rc.right - rc.left, rc.bottom - rc.top);

			hr = m_pD2DFactory->CreateHwndRenderTarget(props, D2D1::HwndRenderTargetProperties(m_hwnd, size, D2D1_PRESENT_OPTIONS_IMMEDIATELY), &m_pHWNDRT);

			if (SUCCEEDED(hr))
			{
				hr = m_pHWNDRT->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::Black), &m_pBlackBrush);
			}
		}

		if (SUCCEEDED(hr))
		{
			m_pHWNDRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
			m_pHWNDRT->SetTextAntialiasMode(D2D1_TEXT_ANTIALIAS_MODE_CLEARTYPE);
			m_pHWNDRT->BeginDraw();
			// vynulujeme transformaci na zadnou (pokud se v minulosti zmenila, tak plati porad dokud se nezmeni zase na jinou)
			m_pHWNDRT->SetTransform(D2D1::Matrix3x2F::Identity());
			m_pHWNDRT->Clear(D2D1::ColorF(D2D1::ColorF::White));
			D2D1_SIZE_F renderTargetSize = m_pHWNDRT->GetSize();

			LARGE_INTEGER qpc;
			LARGE_INTEGER qpc2;
			LARGE_INTEGER qpcf;
			ULONG64 start, konec;

			QueryPerformanceFrequency(&qpcf);
			QueryPerformanceCounter(&qpc);
			QueryThreadCycleTime(hThread, &start);

			for (int i = 0; i < d2dPocet; i++)
			{
				m_pHWNDRT->DrawText(
					sc_helloWorld,
					ARRAYSIZE(sc_helloWorld) - 1,
					m_pTextFormat,
					D2D1::RectF(100, 300, 1000, 380),
					m_pBlackBrush
					);
			}

			hr = m_pHWNDRT->EndDraw();

			QueryThreadCycleTime(hThread, &konec);
			QueryPerformanceCounter(&qpc2);
			long long celk = ((qpc2.QuadPart - qpc.QuadPart) * 1000000) / (qpcf.QuadPart); 
			hwadVysledek[i] = celk;
			chwadVysledek[i] = konec - start;
		}

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			SafeRelease(&m_pHWNDRT);
			SafeRelease(&m_pBlackBrush);
		}
	}

	if (m_pHWNDRT)
	{
		SafeRelease(&m_pHWNDRT);
		SafeRelease(&m_pBlackBrush);
	}

	SafeRelease(&m_pTextFormat);
	SafeRelease(&m_pDWriteFactory);


	double vswdVysledek = 0;
	double vswadVysledek = 0;
	double vhwadVysledek = 0;

	for (int i = 25; i < 75; i++)
	{
		swdTest9 += swdVysledek[i];
		swadTest9 += swadVysledek[i];
		hwadTest9 += hwadVysledek[i];
		cswdTest9 += cswdVysledek[i];
		cswadTest9 += cswadVysledek[i];
		chwadTest9 += chwadVysledek[i];
		vswdVysledek += (double)(swdVysledek[i]) * (double)(swdVysledek[i]);
		vswadVysledek += (double)(swadVysledek[i]) * (double)(swadVysledek[i]);
		vhwadVysledek += (double)(hwadVysledek[i]) * (double)(hwadVysledek[i]);
	}

	swdTest9 = swdTest9 / 50;
	swadTest9 = swadTest9 / 50;
	hwadTest9 = hwadTest9 / 50;
	cswdTest9 = cswdTest9 / 50;
	cswadTest9 = cswadTest9 / 50;
	chwadTest9 = chwadTest9 / 50;
	vswdTest9 = sqrt((vswdVysledek / 50) - ((double)swdTest9 * (double)swdTest9));
	vswdTest9 = (vswdTest9 / swdTest9) * 100;
	vswadTest9 = sqrt((vswadVysledek / 50) - ((double)swadTest9 * (double)swadTest9));
	vswadTest9 = (vswadTest9 / swadTest9) * 100;
	vhwadTest9 = sqrt((vhwadVysledek / 50) - ((double)hwadTest9 * (double)hwadTest9));
	vhwadTest9 = (vhwadTest9 / hwadTest9) * 100;

}